// sigplus_cpp_lcd4x5_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sigplus_cpp_lcd4x5_demo.h"
#include "sigplus_cpp_lcd4x5_demoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigplus_cpp_lcd4x5_demoDlg dialog

CSigplus_cpp_lcd4x5_demoDlg::CSigplus_cpp_lcd4x5_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSigplus_cpp_lcd4x5_demoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSigplus_cpp_lcd4x5_demoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSigplus_cpp_lcd4x5_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSigplus_cpp_lcd4x5_demoDlg)
	DDX_Control(pDX, IDC_COMBO3, m_cboInsurance);
	DDX_Control(pDX, IDC_COMBO2, m_cboNumber);
	DDX_Control(pDX, IDC_COMBO1, m_cboName);
	DDX_Control(pDX, IDC_SIGPLUSCTRL1, m_sigplus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSigplus_cpp_lcd4x5_demoDlg, CDialog)
	//{{AFX_MSG_MAP(CSigplus_cpp_lcd4x5_demoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, cmdStart_Click)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigplus_cpp_lcd4x5_demoDlg message handlers

BOOL CSigplus_cpp_lcd4x5_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	blnCheck1 = false;
	blnCheck2 = false;
	blnHotSpot = false;

	CBitmap m_bmp3;
	m_bmp3.LoadBitmap(IDB_BITMAP3);
	img4x5 = (long)(HBITMAP)m_bmp3.GetSafeHandle();

	//Sets up SigPlus for LCD 4x5 tablet
	m_sigplus.LCDSetTabletMap(0, 320, 240, 180, 120, 2050, 1520);
	m_sigplus.SetTabletXStart(500);
	m_sigplus.SetTabletXStop(2600);
	m_sigplus.SetTabletYStart(500);
	m_sigplus.SetTabletYStop(2100);
	m_sigplus.SetTabletLogicalXSize(2100);
	m_sigplus.SetTabletLogicalYSize(1600);

	m_sigplus.LCDSetWindow(3, 178, 309, 51);
	m_sigplus.SetSigWindow(1, 12, 176, 318, 55);

	//Refresh entire tablet
	m_sigplus.LCDRefresh(0, 0, 0, 320, 240);

	//Clears the SigPlus object of ink
	m_sigplus.ClearTablet();

	m_sigplus.KeyPadAddHotSpot(0, 1, 7, 70, 25, 20);
	m_sigplus.KeyPadAddHotSpot(1, 1, 7, 100, 25, 20);
	m_sigplus.KeyPadAddHotSpot(2, 1, 30, 155, 40, 20);
	m_sigplus.KeyPadAddHotSpot(3, 1, 250, 155, 40, 20);

	m_sigplus.LCDWriteBitmap(1, 2, 0, 0, 320, 240, img4x5);
	m_sigplus.LCDRefresh(2, 0, 0, 320, 240);

	//Sets up LCD to retain data rather than auto clearing it every few seconds
	m_sigplus.SetLCDCaptureMode(2);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSigplus_cpp_lcd4x5_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSigplus_cpp_lcd4x5_demoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSigplus_cpp_lcd4x5_demoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CSigplus_cpp_lcd4x5_demoDlg::cmdStart_Click() 
{
	int index;

	index = m_cboName.GetCurSel();

	if(index >= 0)
	{
		m_cboName.GetLBText(index, strName);
	}

	index = m_cboNumber.GetCurSel();

	if(index >= 0)
	{
		m_cboNumber.GetLBText(index, strNumber);
	}

	index = m_cboInsurance.GetCurSel();

	if(index >= 0)
	{
		m_cboInsurance.GetLBText(index, strInsurance);
	}

	m_sigplus.LCDSetFont(18, 8, 1, 0, 0, 0, "Arial");
	m_sigplus.LCDWriteString(0, 2, 97, 0, 60, 13, 0, strNumber);
	m_sigplus.LCDWriteString(0, 2, 37, 20, 105, 13, 0, strName);
	m_sigplus.LCDWriteString(0, 2, 92, 42, 78, 13, 0, strInsurance);

	m_sigplus.SetLCDCaptureMode(2);

	m_sigplus.SetTabletState(1);
	m_sigplus.SetEventEnableMask(3);
}

BEGIN_EVENTSINK_MAP(CSigplus_cpp_lcd4x5_demoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CSigplus_cpp_lcd4x5_demoDlg)
	ON_EVENT(CSigplus_cpp_lcd4x5_demoDlg, IDC_SIGPLUSCTRL1, 2 /* PenDown */, PenDown, VTS_NONE)
	ON_EVENT(CSigplus_cpp_lcd4x5_demoDlg, IDC_SIGPLUSCTRL1, 3 /* PenUp */, PenUp, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSigplus_cpp_lcd4x5_demoDlg::PenDown() 
{
	CBitmap m_bmp;
	m_bmp.LoadBitmap(IDB_BITMAP1);
	check = (long)(HBITMAP)m_bmp.GetSafeHandle();

	CBitmap m_bmp2;
	m_bmp2.LoadBitmap(IDB_BITMAP2);
	logo = (long)(HBITMAP)m_bmp2.GetSafeHandle();

	if(m_sigplus.KeyPadQueryHotSpot(0) > 0)
	{
		m_sigplus.ClearSigWindow(1);

		if(blnCheck1 == false)
		{
			m_sigplus.LCDWriteBitmap(0, 3, 11, 74, 14, 13, check);
			blnCheck1 = true;
		}
		else
		{
			m_sigplus.LCDRefresh(0, 15, 74, 15, 14);
			blnCheck1 = false;
		}
	}

	if(m_sigplus.KeyPadQueryHotSpot(1) > 0)
	{
		m_sigplus.ClearSigWindow(1);

		if(blnCheck2 == false)
		{
			m_sigplus.LCDWriteBitmap(0, 3, 11, 103, 14, 13, check);
			blnCheck2 = true;
		}
		else
		{
			m_sigplus.LCDRefresh(0, 15, 103, 15, 14);
			blnCheck2 = false;
		}
	}

	if(m_sigplus.KeyPadQueryHotSpot(2) > 0)
	{
		m_sigplus.LCDRefresh(1, 32, 153, 37, 15);
		Sleep(400);
		m_sigplus.LCDRefresh(2, 0, 150, 320, 90);

		blnCheck1 = false;
		blnCheck2 = false;
		blnHotSpot = true;
	}

	if(m_sigplus.KeyPadQueryHotSpot(3) > 0)
	{
		m_sigplus.LCDRefresh(1, 250, 153, 34, 15);
		Sleep(500);
		m_sigplus.LCDRefresh(1, 250, 153, 34, 15);
		m_sigplus.LCDRefresh(0, 0, 0, 320, 240);

		if(m_sigplus.NumberOfTabletPoints() > 0)
		{
			m_sigplus.SetTabletState(0);
			m_sigplus.SetJustifyMode(5);
			m_sigplus.SetSigString(strSignature);

			m_sigplus.LCDSetFont(12, 8, 1, 0, 0, 0, "Arial");
			m_sigplus.LCDWriteString(0, 2, 0, 0, 0, 0, 0, "Prescription Number: " + strNumber);
			m_sigplus.LCDWriteString(0, 2, 0, 20, 0, 0, 0, "Name: " + strName);
			m_sigplus.LCDWriteString(0, 2, 0, 40, 0, 0, 0, "Insurance Provider: " + strInsurance);

			if(blnCheck1 == true)
			{
				m_sigplus.LCDWriteString(0, 2, 0, 60, 0, 0, 0, "You have requested easy-off caps.");
			}
			else
			{
				m_sigplus.LCDWriteString(0, 2, 0, 60, 0, 0, 0, "You have requested child-proof caps.");
			}

			if(blnCheck2 == true)
			{
				m_sigplus.LCDWriteString(0, 2, 0, 80, 0, 0, 0, "You have declined counseling.");
			}
			else
			{
				m_sigplus.LCDWriteString(0, 2, 0, 80, 0, 0, 0, "Please see pharmacist for dosage instructions.");
			}

			m_sigplus.LCDWriteBitmap(0, 2, 95, 120, 105, 30, logo);
			m_sigplus.LCDSetFont(21, 12, 1, 0, 0, 0, "Arial");
			m_sigplus.LCDWriteString(0, 2, 22, 180, 0, 0, 0, "Thank You For Signing!");
			Sleep(6500);
			m_sigplus.SetTabletState(1);
			m_sigplus.LCDRefresh(0, 0, 0, 320, 240);
			m_sigplus.SetLCDCaptureMode(1);
			m_sigplus.SetTabletState(0);
		}
		else
		{
			m_sigplus.LCDSetFont(16, 10, 1, 0, 0, 0, "Arial");
			m_sigplus.LCDWriteString(0, 2, 10, 110, 0, 0, 0, "Please Sign Before Continuing...");
			Sleep(2000);
			blnCheck1 = false;
			blnCheck2 = false;
			m_sigplus.LCDRefresh(2, 0, 0, 320, 240);
			m_sigplus.LCDSetFont(18, 8, 1, 0, 0, 0, "Arial");
			m_sigplus.LCDWriteString(0, 2, 97, 0, 60, 12, 0, strNumber);
			m_sigplus.LCDWriteString(0, 2, 37, 20, 105, 12, 0, strName);
			m_sigplus.LCDWriteString(0, 2, 92, 42, 78, 12, 0, strInsurance);
		}
	}
	
}

void CSigplus_cpp_lcd4x5_demoDlg::PenUp() 
{
	strSignature = m_sigplus.GetSigString();
	m_sigplus.ClearTablet();
	m_sigplus.SetSigString(strSignature);

	if(blnHotSpot == true)
	{
		m_sigplus.ClearTablet();
		blnHotSpot = false;
	}

	m_sigplus.SetEventEnableMask(3);
	
}

BOOL CSigplus_cpp_lcd4x5_demoDlg::DestroyWindow() 
{
	m_sigplus.SetTabletState(1);
	m_sigplus.LCDRefresh(0, 0, 0, 320, 240);  //Clears entire LCD screen
	m_sigplus.SetLCDCaptureMode(1); //Resets regular auto-clear inking
	m_sigplus.SetTabletState(0);
	
	return CDialog::DestroyWindow();
}
